N = 256;
[x,y] = meshgrid(linspace(-1,1,N));

a = -1;
f = 1.*(a*x+y>0);
f = a*x+y;
f = rect(2*x).*rect(2*y);
f = rect(2*x);
f = rect(100*x.^2+100*y.^2);


F = fftshift(fft2(f));
figure(1);
subplot(131);imagesc(f);axis image;colormap gray;axis off;colorbar
subplot(132);imagesc(abs(F));axis image;colormap gray;colorbar;axis off
subplot(133);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;axis off

figure(11);
subplot(131);imagesc(f);axis image;axis off;colorbar
subplot(132);imagesc(abs(F));axis image;colorbar;axis off
subplot(133);imagesc(log(1+abs(F)));axis image;colorbar;axis off

figure(2);
subplot(231);imagesc(f);axis image;colormap gray;colorbar
title('image f');
set(gca,'fontsize',14);
subplot(232);imagesc(abs(F));axis image;colormap gray;colorbar;
title('magnitude of FFT coefficients')
set(gca,'fontsize',14);
subplot(233);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;
title('log of magnitude of FFT coefficients')
set(gca,'fontsize',14);
subplot(234);plot(1:N,f(N/2+1,:),'linewidth',3);axis tight
title('plot of cross section of f')
set(gca,'fontsize',14);
subplot(235);plot((-N/2:N/2-1),abs(F(N/2+1,:)),'linewidth',3);axis tight
title('plot of cross section of (magnitude) Fourier coefficents')
set(gca,'fontsize',14);
subplot(236);plot((-N/2:N/2-1),log(abs(F(N/2+1,:))+1),'linewidth',3);axis tight
title('plot of cross section of (log magnitude) Fourier coefficents')
set(gca,'fontsize',14);

F_horiz = fftshift(fft(f,[],2),2);
figure(10);
tmp = f;
ax1 = subplot(131);surf(tmp/max(tmp(:)));shading interp
tmp = log(abs(F_horiz)+1);
ax2 = subplot(132);surf(tmp/max(tmp(:)));shading interp
tmp = log(abs(F)+1);
ax3 = subplot(133);surf(tmp/max(tmp(:)));shading interp

hlink = linkprop([ax1,ax2,ax3],{'CameraPosition','CameraUpVector'});
rotate3d on
%%
 

k1_dc = 129;
k2_dc = 129;

Fa = F;
Fa(k1_dc,k2_dc) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;axis off
title('fft of step');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap gray;colorbar;axis off
title('modified fft of step');
subplot(223);imagesc(f);axis image;colormap gray;colorbar;axis off
title('step');
subplot(224);imagesc(real(fa));axis image;colormap gray;colorbar;axis off
title('modified step');



%%

Fa = F;
Fa(k1_dc,:) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;axis off
title('fft of step');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap gray;colorbar;axis off
title('modified fft of step');
subplot(223);imagesc(f);axis image;colormap gray;colorbar;axis off
title('step');
subplot(224);imagesc(real(fa));axis image;colormap gray;colorbar;axis off
title('modified step');



%%

Fa = F;
Fa(:,k2_dc) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;axis off
title('fft of step');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap gray;colorbar;axis off
title('modified fft of step');
subplot(223);imagesc(f);axis image;colormap gray;colorbar;axis off
title('step');
subplot(224);imagesc(real(fa));axis image;colormap gray;colorbar;axis off
title('modified step');


%%

Fa = F;
Fa(:,k2_dc) = 0;
Fa(k1_dc,:) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;axis off
title('fft of step');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap gray;colorbar;axis off
title('modified fft of step');
subplot(223);imagesc(f);axis image;colormap gray;colorbar;axis off
title('step');
subplot(224);imagesc(real(fa));axis image;colormap gray;colorbar;axis off
title('modified step');


%%

Fa = F;
c = 20;
Fa(:,1:k2_dc-c) = 0;
Fa(:,k2_dc+c:end) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;axis off
title('fft of step');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap gray;colorbar;axis off
title('modified fft of step');
subplot(223);imagesc(f);axis image;colormap gray;colorbar;axis off
title('step');
subplot(224);imagesc(real(fa));axis image;colormap gray;colorbar;axis off
title('modified step');

%%

Fa = F;
c = 5;
Fa(1:k1_dc-c,:) = 0;
Fa(k1_dc+c:end,:) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;axis off
title('fft of step');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap gray;colorbar;axis off
title('modified fft of step');
subplot(223);imagesc(f);axis image;colormap gray;colorbar;axis off
title('step');
subplot(224);imagesc(real(fa));axis image;colormap gray;colorbar;axis off
title('modified step');

%%

Fa = F;
c = 20;
Fa(1:k1_dc-c,:) = 0;
Fa(k1_dc+c:end,:) = 0;
Fa(:,1:k2_dc-c) = 0;
Fa(:,k2_dc+c:end) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;axis off
title('fft of step');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap gray;colorbar;axis off
title('modified fft of step');
subplot(223);imagesc(f);axis image;colormap gray;colorbar;axis off
title('step');
subplot(224);imagesc(real(fa));axis image;colormap gray;colorbar;axis off
title('modified step');


%%

Fa = F;
c = 20;
Fa(k1_dc-c:k1_dc+c,k2_dc-c:k2_dc+c) = 0;
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;axis off
title('fft of step');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap gray;colorbar;axis off
title('modified fft of step');
subplot(223);imagesc(f);axis image;colormap gray;colorbar;axis off
title('step');
subplot(224);imagesc(real(fa));axis image;colormap gray;colorbar;axis off
title('modified step');


%%
Fa = abs(F);
fa = (ifft2(fftshift(Fa)));
figure(3);
subplot(221);imagesc(log(1+abs(F)));axis image;colormap gray;colorbar;axis off
title('fft of step');
subplot(222);imagesc(log(1+abs(Fa)));axis image;colormap gray;colorbar;axis off
title('modified fft of step');
subplot(223);imagesc(f);axis image;colormap gray;colorbar;axis off
title('step');
subplot(224);imagesc(real(fa));axis image;colormap gray;colorbar;axis off
title('modified step');


